Make cargo packages respect MAKE_JOBS.

Index: devel/cbindgen/Makefile
===================================================================
RCS file: /cvsroot/pkgsrc/devel/cbindgen/Makefile,v
retrieving revision 1.11
diff -u -r1.11 Makefile
--- devel/cbindgen/Makefile	9 Jan 2020 14:56:28 -0000	1.11
+++ devel/cbindgen/Makefile	18 Jan 2020 20:59:40 -0000
@@ -48,7 +48,7 @@
 INSTALLATION_DIRS=	bin
 
 do-build:
-	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release
+	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release -j${EFFECTIVE_MAKE_JOBS}
 
 do-install:
 	${INSTALL_PROGRAM} ${WRKSRC}/target/release/cbindgen ${DESTDIR}${PREFIX}/bin
Index: graphics/librsvg/Makefile
===================================================================
RCS file: /cvsroot/pkgsrc/graphics/librsvg/Makefile,v
retrieving revision 1.113
diff -u -r1.113 Makefile
--- graphics/librsvg/Makefile	31 Dec 2019 11:36:52 -0000	1.113
+++ graphics/librsvg/Makefile	18 Jan 2020 20:59:40 -0000
@@ -11,6 +11,7 @@
 LICENSE=	gnu-lgpl-v2
 
 MAKE_JOBS_SAFE=	NO
+MAKE_FLAGS+=	CARGO_MAKE_JOBS=-j${EFFECTIVE_MAKE_JOBS}
 
 USE_LIBTOOL=		yes
 USE_TOOLS+=		pkg-config gmake aclocal autoconf automake
Index: graphics/librsvg/distinfo
===================================================================
RCS file: /cvsroot/pkgsrc/graphics/librsvg/distinfo,v
retrieving revision 1.43
diff -u -r1.43 distinfo
--- graphics/librsvg/distinfo	31 Dec 2019 11:36:52 -0000	1.43
+++ graphics/librsvg/distinfo	18 Jan 2020 20:59:42 -0000
@@ -576,3 +576,4 @@
 RMD160 (xml-rs-0.8.0.crate) = 8ed8d898ab2d1b1ef5c6d391da2c9bfe4bba95a7
 SHA512 (xml-rs-0.8.0.crate) = 94f0bc729d58564d63b4708518313e3dc7fe7c6ff9ac94019df1507d7ce7bd6428f2bc16fb116a9d676415a94812ce1e54e30b469a2a9b5fe29dc82486c536cd
 Size (xml-rs-0.8.0.crate) = 50974 bytes
+SHA1 (patch-Makefile.in) = d8cd4f26c6744a458d8f0735da29653c60ab66f4
Index: graphics/librsvg/patches/patch-Makefile.in
===================================================================
RCS file: graphics/librsvg/patches/patch-Makefile.in
diff -N graphics/librsvg/patches/patch-Makefile.in
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ graphics/librsvg/patches/patch-Makefile.in	18 Jan 2020 20:59:42 -0000
@@ -0,0 +1,15 @@
+$NetBSD$
+
+Make it possible to respect MAKE_JOBS.
+
+--- Makefile.in.orig	2019-11-21 16:59:53.000000000 +0000
++++ Makefile.in
+@@ -1761,7 +1761,7 @@ librsvg_c_api.la: $(librsvg_c_api_la_OBJ
+ 	PKG_CONFIG_ALLOW_CROSS=1						\
+ 	PKG_CONFIG='$(PKG_CONFIG)'						\
+ 	CARGO_TARGET_DIR=$(CARGO_TARGET_DIR)					\
+-	$(CARGO) --locked build $(CARGO_VERBOSE) $(CARGO_TARGET_ARGS) $(CARGO_RELEASE_ARGS) \
++	$(CARGO) --locked build $(CARGO_MAKE_JOBS) $(CARGO_VERBOSE) $(CARGO_TARGET_ARGS) $(CARGO_RELEASE_ARGS) \
+ 	&& if [[ $$($(NM) -g $(RUST_LIB) | grep "T __*clzsi2" -c) -gt 1 ]] ; then \
+ 		$(AR) d $(RUST_LIB) clzsi2.o;					\
+ 	fi \
Index: sysutils/exa/Makefile
===================================================================
RCS file: /cvsroot/pkgsrc/sysutils/exa/Makefile,v
retrieving revision 1.1
diff -u -r1.1 Makefile
--- sysutils/exa/Makefile	18 Jul 2019 00:22:13 -0000	1.1
+++ sysutils/exa/Makefile	18 Jan 2020 20:59:42 -0000
@@ -85,7 +85,7 @@
 			share/zsh/site-functions
 
 do-build:
-	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release
+	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release -j${EFFECTIVE_MAKE_JOBS}
 
 do-install:
 	${INSTALL_PROGRAM} ${WRKSRC}/target/release/exa ${DESTDIR}${PREFIX}/bin
Index: textproc/bat/Makefile
===================================================================
RCS file: /cvsroot/pkgsrc/textproc/bat/Makefile,v
retrieving revision 1.4
diff -u -r1.4 Makefile
--- textproc/bat/Makefile	6 Sep 2019 17:32:04 -0000	1.4
+++ textproc/bat/Makefile	18 Jan 2020 20:59:42 -0000
@@ -159,7 +159,7 @@
 INSTALLATION_DIRS=	bin ${PKGMANDIR}/man1
 
 do-build:
-	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release
+	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release -j${EFFECTIVE_MAKE_JOBS}
 
 do-install:
 	${INSTALL_PROGRAM} ${WRKSRC}/target/release/bat ${DESTDIR}${PREFIX}/bin
Index: textproc/ripgrep/Makefile
===================================================================
RCS file: /cvsroot/pkgsrc/textproc/ripgrep/Makefile,v
retrieving revision 1.6
diff -u -r1.6 Makefile
--- textproc/ripgrep/Makefile	3 Dec 2019 16:34:29 -0000	1.6
+++ textproc/ripgrep/Makefile	18 Jan 2020 20:59:42 -0000
@@ -79,7 +79,7 @@
 INSTALLATION_DIRS=	bin
 
 do-build:
-	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release
+	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release -j${EFFECTIVE_MAKE_JOBS}
 
 do-install:
 	${INSTALL_PROGRAM} ${WRKSRC}/target/release/rg ${DESTDIR}${PREFIX}/bin
Index: www/geckodriver/Makefile
===================================================================
RCS file: /cvsroot/pkgsrc/www/geckodriver/Makefile,v
retrieving revision 1.8
diff -u -r1.8 Makefile
--- www/geckodriver/Makefile	22 Jul 2019 23:48:31 -0000	1.8
+++ www/geckodriver/Makefile	18 Jan 2020 20:59:43 -0000
@@ -170,7 +170,7 @@
 	cp ${FILESDIR}/Cargo.lock ${WRKSRC}/Cargo.lock
 
 do-build:
-	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release
+	cd ${WRKSRC} && ${SETENV} ${MAKE_ENV} ${PREFIX}/bin/cargo build --locked --frozen --release -j${EFFECTIVE_MAKE_JOBS}
 
 do-install:
 	${INSTALL_PROGRAM} ${WRKSRC}/target/release/geckodriver ${DESTDIR}${PREFIX}/bin