? firefox/work
? firefox-l10n/work
Index: firefox/Makefile
===================================================================
RCS file: /cvsroot/pkgsrc/www/firefox/Makefile,v
retrieving revision 1.344
diff -u -r1.344 Makefile
--- firefox/Makefile	3 Oct 2018 17:30:30 -0000	1.344
+++ firefox/Makefile	24 Oct 2018 00:07:25 -0000
@@ -1,8 +1,8 @@
 # $NetBSD: Makefile,v 1.344 2018/10/03 17:30:30 maya Exp $
 
 FIREFOX_VER=		${MOZ_BRANCH}${MOZ_BRANCH_MINOR}
-MOZ_BRANCH=		62.0
-MOZ_BRANCH_MINOR=	.3
+MOZ_BRANCH=		63.0
+#MOZ_BRANCH_MINOR=	
 
 DISTNAME=	firefox-${FIREFOX_VER}.source
 PKGNAME=	${DISTNAME:S/.source//:S/b/beta/:S/esr//}
Index: firefox/distinfo
===================================================================
RCS file: /cvsroot/pkgsrc/www/firefox/distinfo,v
retrieving revision 1.326
diff -u -r1.326 distinfo
--- firefox/distinfo	3 Oct 2018 17:30:30 -0000	1.326
+++ firefox/distinfo	24 Oct 2018 00:07:25 -0000
@@ -1,21 +1,21 @@
 $NetBSD: distinfo,v 1.326 2018/10/03 17:30:30 maya Exp $
 
-SHA1 (firefox-62.0.3.source.tar.xz) = 063b22b863cec227608d0195979cc5bbaa6d3f3c
-RMD160 (firefox-62.0.3.source.tar.xz) = 4f6e5e6898c2b62a454ebc9998ead032b049469d
-SHA512 (firefox-62.0.3.source.tar.xz) = 487bb7791284367158c79cf7918fecf3d598627a6416e679aeb5d22626089aeffe07762fa2389819ba881c90ece1c5a83cf2d85b2def15b8d5ba0ed1c498b527
-Size (firefox-62.0.3.source.tar.xz) = 259531444 bytes
+SHA1 (firefox-63.0.source.tar.xz) = 6ea61d6b30a7b10584af8d1a1282e8400834de4d
+RMD160 (firefox-63.0.source.tar.xz) = 4e4d7ed31a17da41eeada9c9e99fe722c5cddf48
+SHA512 (firefox-63.0.source.tar.xz) = a206ea2968a6feec11eb4d03c294de29478f2f586145235c3beeba1f1233f0de13a50a20f56933eff6d4dd3729ad5aa8c89342638c8dd80b4642c579a0585b12
+Size (firefox-63.0.source.tar.xz) = 265957640 bytes
 SHA1 (patch-aa) = 94c03ed9a0e72bb87c850f2e1965fb8755933822
-SHA1 (patch-browser_app_profile_firefox.js) = 30e93d7817c7e17b96ba96d3d3fb3701020260d4
+SHA1 (patch-browser_app_profile_firefox.js) = 13f43b7f9426c2aa6913920c886a8c60cbee7451
 SHA1 (patch-build_moz.configure_old.configure) = 3b887ca0ee9e42558f3a72429f88a19676b309d9
 SHA1 (patch-build_moz.configure_rust.configure) = bdfb66b5fa215affa3b273ea58d394f3eb7f7102
 SHA1 (patch-dom_media_CubebUtils.cpp) = 3632cd0dd4b95f53f01050b8898b33fe198916b6
 SHA1 (patch-gfx_angle_checkout_src_common_third__party_smhasher_src_PMurHash.cpp) = f1d0adae2873545818072adb4e8599267bc4e6c5
 SHA1 (patch-gfx_angle_checkout_src_compiler_translator_InfoSink.h) = 96330213707b218b6cfc71589fbf67d14b268dfc
-SHA1 (patch-gfx_webrender_src_query.rs) = 6434b0fc1d6441ddb555a2a3b199564b488ec336
+SHA1 (patch-gfx_webrender_src_device_query__gl.rs) = 8f8ecc77d627df3aed67767f7b67cba5cd8ab6f3
 SHA1 (patch-image_decoders_nsJPEGDecoder.cpp) = ed86c3fbb3aef753eec6f6a97940594aac5f3f2f
 SHA1 (patch-ipc_chromium_src_base_lock__impl__posix.cc) = 16e37fe54ba1d8d233f6b04dbd06e248305d7f6e
 SHA1 (patch-ipc_chromium_src_base_message__pump__libevent.cc) = 99b9f3f9dd88f1c8008d2fb6058450695394f5cf
-SHA1 (patch-ipc_chromium_src_base_platform__thread__posix.cc) = 5b0bfe78e105cc3f395d5afda25a50afc6289f03
+SHA1 (patch-ipc_chromium_src_base_platform__thread__posix.cc) = feae2285f0a5344a4dee0151cc7e73fe5607a275
 SHA1 (patch-ipc_glue_CrossProcessSemaphore.h) = 778a569887d8ad082abc2fa2fe89a0a943e84d64
 SHA1 (patch-ipc_glue_CrossProcessSemaphore__posix.cpp) = 3052338871447cedaeafe8369afe82233183c884
 SHA1 (patch-ipc_glue_GeckoChildProcessHost.cpp) = 260c29bacd8bf265951b7a412f850bf2b292c836
@@ -35,7 +35,7 @@
 SHA1 (patch-media_webrtc_trunk_webrtc_modules_video__capture_linux_device__info__linux.cc) = 0141dd1372c13ea1fce6e2f5ffb65e0cb0f3a13e
 SHA1 (patch-media_webrtc_trunk_webrtc_modules_video__capture_linux_video__capture__linux.cc) = a69bc7b7096b410582e725f9dbec57fee90d6686
 SHA1 (patch-modules_pdfium_update.sh) = b0bf091325c9322c54880de067871354cd689038
-SHA1 (patch-servo_components_style_build__gecko.rs) = fca2260a70b496fc010f165ff4d68788b7e28632
+SHA1 (patch-servo_components_style_build__gecko.rs) = de28e49404c077ba6147b010be49ed39e99e9820
 SHA1 (patch-toolkit_components_terminator_nsTerminator.cpp) = 5b6d2e5c9f685d32894898d3ef3aec09a1a1e5ce
 SHA1 (patch-toolkit_library_moz.build) = ecb6125e996d5496335c58ecd3433ad3214f29f0
 SHA1 (patch-toolkit_moz.configure) = 40ee147cc1d2c62dd6c83b3f67ce9e61f758ea57
Index: firefox/mozilla-common.mk
===================================================================
RCS file: /cvsroot/pkgsrc/www/firefox/mozilla-common.mk,v
retrieving revision 1.116
diff -u -r1.116 mozilla-common.mk
--- firefox/mozilla-common.mk	21 Sep 2018 10:11:19 -0000	1.116
+++ firefox/mozilla-common.mk	24 Oct 2018 00:07:25 -0000
@@ -32,6 +32,8 @@
 #CONFIGURE_ARGS+=	--enable-eme=widevine
 .endif
 
+BUILD_DEPENDS+=		cbindgen-*:../../lang/cbindgen
+
 # For rustc/cargo detection
 CONFIGURE_ARGS+=	--target=${MACHINE_GNU_PLATFORM:Q}
 CONFIGURE_ARGS+=	--host=${MACHINE_GNU_PLATFORM:Q}
@@ -62,6 +64,9 @@
 
 CXXFLAGS+=		-D__HAVE_INLINE___ISINF
 
+# PR toolchain/53679
+CXXFLAGS.NetBSD+=	-U_GLIBCXX_USE_FLOAT128
+
 CHECK_PORTABILITY_SKIP+=${MOZILLA_DIR}security/nss/tests/libpkix/libpkix.sh
 CHECK_PORTABILITY_SKIP+=${MOZILLA_DIR}security/nss/tests/multinit/multinit.sh
 CHECK_PORTABILITY_SKIP+=${MOZILLA_DIR}js/src/tests/update-test262.sh
Index: firefox/patches/patch-browser_app_profile_firefox.js
===================================================================
RCS file: /cvsroot/pkgsrc/www/firefox/patches/patch-browser_app_profile_firefox.js,v
retrieving revision 1.8
diff -u -r1.8 patch-browser_app_profile_firefox.js
--- firefox/patches/patch-browser_app_profile_firefox.js	28 Jun 2018 13:52:37 -0000	1.8
+++ firefox/patches/patch-browser_app_profile_firefox.js	24 Oct 2018 00:07:25 -0000
@@ -1,17 +1,21 @@
 $NetBSD: patch-browser_app_profile_firefox.js,v 1.8 2018/06/28 13:52:37 ryoon Exp $
 
---- browser/app/profile/firefox.js.orig	2018-06-21 20:03:42.000000000 +0000
+--- browser/app/profile/firefox.js.orig	2018-10-18 20:06:03.000000000 +0000
 +++ browser/app/profile/firefox.js
-@@ -1737,6 +1737,12 @@ pref("app.shield.optoutstudies.enabled",
- pref("app.shield.optoutstudies.enabled", false);
- #endif
+@@ -1772,6 +1772,16 @@ pref("app.shield.optoutstudies.enabled",
+ // Multi-lingual preferences
+ pref("intl.multilingual.enabled", false);
  
++
++
 +// Select UI locale from LANG/LC_MESSAGE environmental variables
 +pref("intl.locale.requested", "");
 +
++#ifdef __NetBSD__
 +// Disable multiprocess window support. Workaround for PR 53273.
 +pref("browser.tabs.remote.autostart", false);
++#endif
 +
- // Savant Shield study preferences
- pref("shield.savant.enabled", false);
- pref("shield.savant.loglevel", "warn");
+ // Prio preferences
+ // Curve25519 public keys for Prio servers
+ pref("prio.publicKeyA", "35AC1C7576C7C6EDD7FED6BCFC337B34D48CB4EE45C86BEEFB40BD8875707733");
Index: firefox/patches/patch-gfx_webrender_src_device_query__gl.rs
===================================================================
RCS file: firefox/patches/patch-gfx_webrender_src_device_query__gl.rs
diff -N firefox/patches/patch-gfx_webrender_src_device_query__gl.rs
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ firefox/patches/patch-gfx_webrender_src_device_query__gl.rs	24 Oct 2018 00:07:25 -0000
@@ -0,0 +1,28 @@
+$NetBSD$
+
+--- gfx/webrender/src/device/query_gl.rs.orig	2018-10-18 20:06:05.000000000 +0000
++++ gfx/webrender/src/device/query_gl.rs
+@@ -283,6 +283,7 @@ pub struct GpuMarker {
+ impl GpuMarker {
+     fn new(gl: &Rc<gl::Gl>, message: &str, ext_debug_marker: bool) -> Self {
+         let gl = if ext_debug_marker {
++#[cfg(not(target_arch = "x86"))]
+             gl.push_group_marker_ext(message);
+             Some(Rc::clone(gl))
+         } else {
+@@ -293,6 +294,7 @@ impl GpuMarker {
+ 
+     fn fire(gl: &Rc<gl::Gl>, message: &str, ext_debug_marker: bool) {
+         if ext_debug_marker {
++#[cfg(not(target_arch = "x86"))]
+             gl.insert_event_marker_ext(message);
+         }
+     }
+@@ -301,6 +303,7 @@ impl GpuMarker {
+ impl Drop for GpuMarker {
+     fn drop(&mut self) {
+         if let Some(ref gl) = self.gl {
++#[cfg(not(target_arch = "x86"))]
+             gl.pop_group_marker_ext();
+         }
+     }
Index: firefox/patches/patch-gfx_webrender_src_query.rs
===================================================================
RCS file: firefox/patches/patch-gfx_webrender_src_query.rs
diff -N firefox/patches/patch-gfx_webrender_src_query.rs
--- firefox/patches/patch-gfx_webrender_src_query.rs	10 May 2018 20:02:59 -0000	1.1
+++ /dev/null	1 Jan 1970 00:00:00 -0000
@@ -1,25 +0,0 @@
-$NetBSD: patch-gfx_webrender_src_query.rs,v 1.1 2018/05/10 20:02:59 ryoon Exp $
-
---- gfx/webrender/src/query.rs.orig	2018-05-03 16:58:27.000000000 +0000
-+++ gfx/webrender/src/query.rs
-@@ -274,17 +274,20 @@ pub struct GpuMarker {
- 
- impl GpuMarker {
-     fn new(gl: &Rc<gl::Gl>, message: &str) -> Self {
-+#[cfg(not(target_arch = "x86"))]
-         gl.push_group_marker_ext(message);
-         GpuMarker { gl: Rc::clone(gl) }
-     }
- 
-     fn fire(gl: &Rc<gl::Gl>, message: &str) {
-+#[cfg(not(target_arch = "x86"))]
-         gl.insert_event_marker_ext(message);
-     }
- }
- 
- impl Drop for GpuMarker {
-     fn drop(&mut self) {
-+#[cfg(not(target_arch = "x86"))]
-         self.gl.pop_group_marker_ext();
-     }
- }
Index: firefox/patches/patch-ipc_chromium_src_base_platform__thread__posix.cc
===================================================================
RCS file: /cvsroot/pkgsrc/www/firefox/patches/patch-ipc_chromium_src_base_platform__thread__posix.cc,v
retrieving revision 1.10
diff -u -r1.10 patch-ipc_chromium_src_base_platform__thread__posix.cc
--- firefox/patches/patch-ipc_chromium_src_base_platform__thread__posix.cc	26 Jun 2018 09:37:10 -0000	1.10
+++ firefox/patches/patch-ipc_chromium_src_base_platform__thread__posix.cc	24 Oct 2018 00:07:25 -0000
@@ -1,7 +1,7 @@
 $NetBSD: patch-ipc_chromium_src_base_platform__thread__posix.cc,v 1.10 2018/06/26 09:37:10 jperkin Exp $
 
-* Support NetBSD
-* Support Solaris (we can't rely on pthread_setname_np so ignore it).
+* Support NetBSD and Solaris
+* Support Solaris
 
 --- ipc/chromium/src/base/platform_thread_posix.cc.orig	2018-06-05 19:47:29.000000000 +0000
 +++ ipc/chromium/src/base/platform_thread_posix.cc
@@ -15,12 +15,3 @@
  #elif defined(OS_LINUX)
  #include <sys/syscall.h>
  #include <sys/prctl.h>
-@@ -103,7 +105,7 @@ void PlatformThread::SetName(const char*
-   pthread_setname_np(pthread_self(), "%s", (void *)name);
- #elif defined(OS_BSD) && !defined(__GLIBC__)
-   pthread_set_name_np(pthread_self(), name);
--#elif defined(OS_SOLARIS)
-+#elif defined(notOS_SOLARIS)
-   pthread_setname_np(pthread_self(), name);
- #else
- #endif
Index: firefox/patches/patch-servo_components_style_build__gecko.rs
===================================================================
RCS file: /cvsroot/pkgsrc/www/firefox/patches/patch-servo_components_style_build__gecko.rs,v
retrieving revision 1.1
diff -u -r1.1 patch-servo_components_style_build__gecko.rs
--- firefox/patches/patch-servo_components_style_build__gecko.rs	30 Sep 2017 05:34:12 -0000	1.1
+++ firefox/patches/patch-servo_components_style_build__gecko.rs	24 Oct 2018 00:07:25 -0000
@@ -1,10 +1,12 @@
 $NetBSD: patch-servo_components_style_build__gecko.rs,v 1.1 2017/09/30 05:34:12 ryoon Exp $
 
-* Fix build with __uint32_t etc. not found errors on NetBSD/amd64 8.99.2
+* Hack around netbsd #define uint32_t
+see https://mail-index.netbsd.org/tech-userlevel/2018/09/08/msg011381.html
+(__uint32_t etc. not found errors on NetBSD/amd64 8.99.2)
 
---- servo/components/style/build_gecko.rs.orig	2017-09-14 20:15:56.000000000 +0000
+--- servo/components/style/build_gecko.rs.orig	2018-10-18 20:06:10.000000000 +0000
 +++ servo/components/style/build_gecko.rs
-@@ -546,6 +546,8 @@ mod bindings {
+@@ -557,6 +560,8 @@ mod bindings {
                  .borrowed_type(ty)
                  .zero_size_type(ty, &structs_types);
          }