Index: share/man/man7/hier.7
===================================================================
RCS file: /cvsroot/src/share/man/man7/hier.7,v
retrieving revision 1.140
diff -u -r1.140 hier.7
--- share/man/man7/hier.7	12 May 2020 10:20:16 -0000	1.140
+++ share/man/man7/hier.7	7 Nov 2020 08:32:17 -0000
@@ -29,7 +29,7 @@
 .\"
 .\"	@(#)hier.7	8.5 (Berkeley) 6/1/94
 .\"
-.Dd May 12, 2020
+.Dd November 7, 2020
 .Dt HIER 7
 .Os
 .Sh NAME
@@ -427,7 +427,9 @@
 .It Pa include/
 X11 include files.
 .It Pa lib/
-X11 libraries.
+X11 libraries and utility files.
+.It Pa share/doc
+Miscellaneous system-wide text files.
 .El
 .Pp
 .It Pa bin/
Index: etc/mtree/NetBSD.dist.Xorg
===================================================================
RCS file: /cvsroot/src/etc/mtree/NetBSD.dist.Xorg,v
retrieving revision 1.26
diff -u -r1.26 NetBSD.dist.Xorg
--- etc/mtree/NetBSD.dist.Xorg	19 Jan 2020 00:58:14 -0000	1.26
+++ etc/mtree/NetBSD.dist.Xorg	7 Nov 2020 08:32:18 -0000
@@ -178,6 +178,8 @@
 ./usr/X11R7/man/man7
 ./usr/X11R7/share
 ./usr/X11R7/share/aclocal
+./usr/X11R7/share/docs
+./usr/X11R7/share/docs/liberation-ttf
 ./usr/X11R7/share/examples
 ./usr/X11R7/share/examples/ssh-askpass
 ./usr/X11R7/share/libdrm
Index: external/ofl/Makefile
===================================================================
RCS file: external/ofl/Makefile
diff -N external/ofl/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ external/ofl/Makefile	7 Nov 2020 08:32:18 -0000
@@ -0,0 +1,3 @@
+SUBDIR+=	font-liberation-ttf share.doc
+
+.include <bsd.subdir.mk>
Index: external/ofl/font-liberation-ttf/Makefile
===================================================================
RCS file: external/ofl/font-liberation-ttf/Makefile
diff -N external/ofl/font-liberation-ttf/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ external/ofl/font-liberation-ttf/Makefile	7 Nov 2020 08:32:18 -0000
@@ -0,0 +1,21 @@
+#	$NetBSD: Makefile,v 1.1.1.1 2008/07/29 05:01:23 mrg Exp $
+
+.include <bsd.own.mk>
+
+FONTSUBDIR=	TTF
+FONTSRCPKG=	font-liberation-ttf
+FILESDIR=	${X11FONTDIR}/TTF
+
+.PATH:	${X11SRCDIR}/external/ofl/${FONTSRCPKG}/src \
+	${X11SRCDIR}/external/ofl/${FONTSRCPKG}/dist
+
+FILES=		LiberationMono-Bold.ttf LiberationMono-BoldItalic.ttf \
+		LiberationMono-Italic.ttf LiberationMono-Regular.ttf \
+		LiberationSans-Bold.ttf LiberationSans-BoldItalic.ttf \
+		LiberationSans-Italic.ttf LiberationSans-Regular.ttf \
+		LiberationSerif-Bold.ttf LiberationSerif-BoldItalic.ttf \
+		LiberationSerif-Italic.ttf LiberationSerif-Regular.ttf
+
+.include <bsd.x11.mk>
+.include <bsd.files.mk>
+.include <bsd.prog.mk>
Index: external/ofl/share.doc/Makefile
===================================================================
RCS file: external/ofl/share.doc/Makefile
diff -N external/ofl/share.doc/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ external/ofl/share.doc/Makefile	7 Nov 2020 08:32:18 -0000
@@ -0,0 +1,5 @@
+#	$NetBSD$
+
+SUBDIR+=	liberation-ttf
+
+.include <bsd.subdir.mk>
Index: external/ofl/share.doc/liberation-ttf/Makefile
===================================================================
RCS file: external/ofl/share.doc/liberation-ttf/Makefile
diff -N external/ofl/share.doc/liberation-ttf/Makefile
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ external/ofl/share.doc/liberation-ttf/Makefile	7 Nov 2020 08:32:18 -0000
@@ -0,0 +1,10 @@
+#	$NetBSD$
+
+FILESDIR=	${X11SHAREDIR}/docs/liberation-ttf
+
+.PATH:		${X11SRCDIR}/external/ofl/font-liberation-ttf/dist
+FILES+=		LICENSE
+
+includes:
+
+.include <bsd.files.mk>
Index: distrib/sets/lists/xbase/mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/xbase/mi,v
retrieving revision 1.161
diff -u -r1.161 mi
--- distrib/sets/lists/xbase/mi	2 Nov 2020 00:29:49 -0000	1.161
+++ distrib/sets/lists/xbase/mi	7 Nov 2020 08:32:19 -0000
@@ -1715,6 +1715,8 @@
 ./usr/X11R7/man/whatis.db				xbase-x11-man	man,xorg,!makemandb
 ./usr/X11R7/share					base-x11-root	xorg
 ./usr/X11R7/share/aclocal				base-x11-root	xorg
+./usr/X11R7/share/docs					base-x11-root	xorg
+./usr/X11R7/share/docs/liberation-ttf			base-x11-root	xorg
 ./usr/X11R7/share/examples				base-x11-root	xorg
 ./usr/X11R7/share/examples/ssh-askpass			base-x11-root	xorg
 ./usr/X11R7/share/examples/ssh-askpass/SshAskpass-1337.ad	xbase-ssh-askpass-share	xorg
Index: distrib/sets/lists/xfont/mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/xfont/mi,v
retrieving revision 1.44
diff -u -r1.44 mi
--- distrib/sets/lists/xfont/mi	11 Oct 2020 17:49:07 -0000	1.44
+++ distrib/sets/lists/xfont/mi	7 Nov 2020 08:32:22 -0000
@@ -3799,6 +3799,18 @@
 ./usr/X11R7/lib/X11/fonts/75dpi/timR24-ISO8859-4.pcf.gz	xfont	share,xorg,x11fonts
 ./usr/X11R7/lib/X11/fonts/75dpi/timR24-ISO8859-9.pcf.gz	xfont	share,xorg,x11fonts
 ./usr/X11R7/lib/X11/fonts/75dpi/timR24.bdf		xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationMono-Bold.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationMono-BoldItalic.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationMono-Italic.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationMono-Regular.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationSans-Bold.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationSans-BoldItalic.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationSans-Italic.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationSans-Regular.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationSerif-Bold.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationSerif-BoldItalic.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationSerif-Italic.ttf	xfont	share,xorg,x11fonts
+./usr/X11R7/lib/X11/fonts/TTF/LiberationSerif-Regular.ttf	xfont	share,xorg,x11fonts
 ./usr/X11R7/lib/X11/fonts/TTF/Vera.ttf			xfont	share,xorg,x11fonts
 ./usr/X11R7/lib/X11/fonts/TTF/VeraBI.ttf		xfont	share,xorg,x11fonts
 ./usr/X11R7/lib/X11/fonts/TTF/VeraBd.ttf		xfont	share,xorg,x11fonts
@@ -4349,4 +4361,5 @@
 ./usr/X11R7/lib/X11/fonts/util/map-ISO8859-9		xfont	share,xorg,x11fonts
 ./usr/X11R7/lib/X11/fonts/util/map-JISX0201.1976-0	xfont	share,xorg,x11fonts
 ./usr/X11R7/lib/X11/fonts/util/map-KOI8-R		xfont	share,xorg,x11fonts
+./usr/X11R7/share/docs/liberation-ttf/LICENSE		xfont	share,xorg,x11fonts
 ./var/db/obsolete/xfont					xbase-sys-root	xorg