Changes:
- uses int() instead of +0 to force awk-numeric-comparison.
- Update copyright year
- Change name to positive 'always-libgcc' so
  PKG_DEFAULT_OPTIONS=-always-libgcc
  is more natural to do.
- Combine comparison operators

Index: lang/gcc-aux/options.mk
===================================================================
RCS file: /cvsroot/pkgsrc/lang/gcc-aux/options.mk,v
retrieving revision 1.6
diff -u -r1.6 options.mk
--- lang/gcc-aux/options.mk	10 Jul 2017 00:21:31 -0000	1.6
+++ lang/gcc-aux/options.mk	8 Sep 2019 10:55:06 -0000
@@ -4,9 +4,13 @@
 # Disable option until further notice
 
 PKG_OPTIONS_VAR=	PKG_OPTIONS.gcc-aux
-PKG_SUPPORTED_OPTIONS=  fortran objc testsuite static bootstrap #nls
+PKG_SUPPORTED_OPTIONS=  fortran objc testsuite static bootstrap always-libgcc #nls
 PKG_SUGGESTED_OPTIONS=  fortran objc #nls
 
+.if ${OPSYS} != "NetBSD"
+PKG_SUGGESTED_OPTIONS+=	always-libgcc
+.endif
+
 .include "../../mk/bsd.options.mk"
 
 
@@ -30,6 +34,26 @@
 .endif
 .endif
 
+.if empty(PKG_OPTIONS:Malways-libgcc)
+
+.for _libdir_ in ${_OPSYS_LIB_DIRS}
+BASE_LIBGCC!=			find ${_libdir_} -name libgcc_s.so
+BASE_LIBGCC_MATCH_STRING!=	${ECHO} ${BASE_LIBGCC} ${GCC_BRANCH} | \
+				${AWK} -f ../../mk/scripts/larger_symbol_version.awk
+.if ${BASE_LIBGCC_MATCH_STRING:Mnewer}
+DELETE_INSTALLED_LIBGCC=	yes
+.endif
+.endfor
+
+.if ${DELETE_INSTALLED_LIBGCC:Uno}
+post-install:	delete-installed-libgcc
+
+delete-installed-libgcc:
+	${FIND} ${DESTDIR} -name 'libgcc_s.so*' -delete
+
+.endif
+
+.endif
 
 #################################
 ##  ADD LANGUAGE: Objective-C  ##
Index: mk/defaults/options.description
===================================================================
RCS file: /cvsroot/pkgsrc/mk/defaults/options.description,v
retrieving revision 1.592
diff -u -r1.592 options.description
--- mk/defaults/options.description	7 Sep 2019 04:17:42 -0000	1.592
+++ mk/defaults/options.description	8 Sep 2019 10:55:10 -0000
@@ -7,6 +7,7 @@
 afterstep		Enable afterstep support.
 agg			Enable agg support.
 alsa			Enable ALSA support.
+always-libgcc		Install libgcc unconditionally, even if it's older.
 amanda-bsdtar		Enable bsdtar support in Amanda.
 amanda-dump-snap	If dump supports -X, use it.
 amanda-fqdn		Use FQDN's in Amanda.
Index: mk/scripts/larger_symbol_version.awk
===================================================================
RCS file: mk/scripts/larger_symbol_version.awk
diff -N mk/scripts/larger_symbol_version.awk
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ mk/scripts/larger_symbol_version.awk	8 Sep 2019 10:55:10 -0000
@@ -0,0 +1,81 @@
+#!/usr/bin/awk -f
+
+# $NetBSD$
+
+# Copyright (c) 2019 Maya Rashish <maya@NetBSD.org>.
+# All rights reserved.
+#
+# This code is derived from software contributed to The NetBSD Foundation
+# by Maya Rashish.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in
+#    the documentation and/or other materials provided with the
+#    distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+# FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+# AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+# For each absolute symbol in an ELF binary, extract the component
+# of the symbol name that looks like a version.
+#
+# If the supplied version is larger, return 1
+# 
+# example:
+#     echo "/usr/lib/libgcc_s.so 3.4" | awk -f larger_symbol_version.awk
+
+BEGIN {
+	nm = ENVIRON["NM"]
+	if (nm == "")
+		nm = "nm"
+}
+
+
+function largest_symbol_version(ELF) {
+	cmd = nm " -D " ELF " 2>/dev/null"
+	while ((cmd | getline) > 0) {
+		# Absolute symbol of the form ALPHABET_3.4
+		if (($2 == "A") && ($3 ~ /[A-Za-z_]*[0-9]*\.[0-9]*/)) {
+			split($3, matches, ".")
+
+			sub(/[A-Za-z_]*/,"",matches[1])
+
+			current_major = int(matches[1])
+			current_minor = int(matches[2])
+
+			if ((current_major > target_major) ||
+			   ((current_major == target_major) &&
+			    (current_minor > target_minor))) {
+				print "the version of " ELF " is newer than target version " target_major "." target_minor
+				exit 0
+			}
+		}
+	}
+	print "the version of " ELF " is older or equal to target version " target_major "." target_minor
+	exit 0
+}
+
+{ 
+
+	split($NF, target_version, ".")
+	target_major = target_version[1]
+	target_minor = target_version[2]
+
+	largest_symbol_version($1);
+}