Index: dist/drm/amd/amdgpu/amdgpu_ci_dpm.c
===================================================================
RCS file: /cvsroot/src/sys/external/bsd/drm2/dist/drm/amd/amdgpu/amdgpu_ci_dpm.c,v
retrieving revision 1.2
diff -u -r1.2 amdgpu_ci_dpm.c
--- dist/drm/amd/amdgpu/amdgpu_ci_dpm.c	27 Aug 2018 14:24:03 -0000	1.2
+++ dist/drm/amd/amdgpu/amdgpu_ci_dpm.c	3 Sep 2019 16:34:08 -0000
@@ -55,8 +55,8 @@
 #include "gmc/gmc_7_1_d.h"
 #include "gmc/gmc_7_1_sh_mask.h"
 
-MODULE_FIRMWARE("radeon/bonaire_smc.bin");
-MODULE_FIRMWARE("radeon/hawaii_smc.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_smc.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_smc.bin");
 
 #define MC_CG_ARB_FREQ_F0           0x0a
 #define MC_CG_ARB_FREQ_F1           0x0b
Index: dist/drm/amd/amdgpu/amdgpu_cik_sdma.c
===================================================================
RCS file: /cvsroot/src/sys/external/bsd/drm2/dist/drm/amd/amdgpu/amdgpu_cik_sdma.c,v
retrieving revision 1.2
diff -u -r1.2 amdgpu_cik_sdma.c
--- dist/drm/amd/amdgpu/amdgpu_cik_sdma.c	27 Aug 2018 14:24:03 -0000	1.2
+++ dist/drm/amd/amdgpu/amdgpu_cik_sdma.c	3 Sep 2019 16:34:09 -0000
@@ -62,16 +62,16 @@
 static void cik_sdma_set_vm_pte_funcs(struct amdgpu_device *adev);
 static int cik_sdma_soft_reset(void *handle);
 
-MODULE_FIRMWARE("radeon/bonaire_sdma.bin");
-MODULE_FIRMWARE("radeon/bonaire_sdma1.bin");
-MODULE_FIRMWARE("radeon/hawaii_sdma.bin");
-MODULE_FIRMWARE("radeon/hawaii_sdma1.bin");
-MODULE_FIRMWARE("radeon/kaveri_sdma.bin");
-MODULE_FIRMWARE("radeon/kaveri_sdma1.bin");
-MODULE_FIRMWARE("radeon/kabini_sdma.bin");
-MODULE_FIRMWARE("radeon/kabini_sdma1.bin");
-MODULE_FIRMWARE("radeon/mullins_sdma.bin");
-MODULE_FIRMWARE("radeon/mullins_sdma1.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_sdma.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_sdma1.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_sdma.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_sdma1.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_sdma.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_sdma1.bin");
+MODULE_FIRMWARE("radeon/new_kabini_sdma.bin");
+MODULE_FIRMWARE("radeon/new_kabini_sdma1.bin");
+MODULE_FIRMWARE("radeon/new_mullins_sdma.bin");
+MODULE_FIRMWARE("radeon/new_mullins_sdma1.bin");
 
 u32 amdgpu_cik_gpu_check_soft_reset(struct amdgpu_device *adev);
 
Index: dist/drm/amd/amdgpu/amdgpu_gfx_v7_0.c
===================================================================
RCS file: /cvsroot/src/sys/external/bsd/drm2/dist/drm/amd/amdgpu/amdgpu_gfx_v7_0.c,v
retrieving revision 1.2
diff -u -r1.2 amdgpu_gfx_v7_0.c
--- dist/drm/amd/amdgpu/amdgpu_gfx_v7_0.c	27 Aug 2018 14:24:03 -0000	1.2
+++ dist/drm/amd/amdgpu/amdgpu_gfx_v7_0.c	3 Sep 2019 16:34:16 -0000
@@ -66,36 +66,36 @@
 static void gfx_v7_0_set_gds_init(struct amdgpu_device *adev);
 int gfx_v7_0_get_cu_info(struct amdgpu_device *, struct amdgpu_cu_info *);
 
-MODULE_FIRMWARE("radeon/bonaire_pfp.bin");
-MODULE_FIRMWARE("radeon/bonaire_me.bin");
-MODULE_FIRMWARE("radeon/bonaire_ce.bin");
-MODULE_FIRMWARE("radeon/bonaire_rlc.bin");
-MODULE_FIRMWARE("radeon/bonaire_mec.bin");
-
-MODULE_FIRMWARE("radeon/hawaii_pfp.bin");
-MODULE_FIRMWARE("radeon/hawaii_me.bin");
-MODULE_FIRMWARE("radeon/hawaii_ce.bin");
-MODULE_FIRMWARE("radeon/hawaii_rlc.bin");
-MODULE_FIRMWARE("radeon/hawaii_mec.bin");
-
-MODULE_FIRMWARE("radeon/kaveri_pfp.bin");
-MODULE_FIRMWARE("radeon/kaveri_me.bin");
-MODULE_FIRMWARE("radeon/kaveri_ce.bin");
-MODULE_FIRMWARE("radeon/kaveri_rlc.bin");
-MODULE_FIRMWARE("radeon/kaveri_mec.bin");
-MODULE_FIRMWARE("radeon/kaveri_mec2.bin");
-
-MODULE_FIRMWARE("radeon/kabini_pfp.bin");
-MODULE_FIRMWARE("radeon/kabini_me.bin");
-MODULE_FIRMWARE("radeon/kabini_ce.bin");
-MODULE_FIRMWARE("radeon/kabini_rlc.bin");
-MODULE_FIRMWARE("radeon/kabini_mec.bin");
-
-MODULE_FIRMWARE("radeon/mullins_pfp.bin");
-MODULE_FIRMWARE("radeon/mullins_me.bin");
-MODULE_FIRMWARE("radeon/mullins_ce.bin");
-MODULE_FIRMWARE("radeon/mullins_rlc.bin");
-MODULE_FIRMWARE("radeon/mullins_mec.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_pfp.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_me.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_ce.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_rlc.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_mec.bin");
+
+MODULE_FIRMWARE("radeon/new_hawaii_pfp.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_me.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_ce.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_rlc.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_mec.bin");
+
+MODULE_FIRMWARE("radeon/new_kaveri_pfp.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_me.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_ce.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_rlc.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_mec.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_mec2.bin");
+
+MODULE_FIRMWARE("radeon/new_kabini_pfp.bin");
+MODULE_FIRMWARE("radeon/new_kabini_me.bin");
+MODULE_FIRMWARE("radeon/new_kabini_ce.bin");
+MODULE_FIRMWARE("radeon/new_kabini_rlc.bin");
+MODULE_FIRMWARE("radeon/new_kabini_mec.bin");
+
+MODULE_FIRMWARE("radeon/new_mullins_pfp.bin");
+MODULE_FIRMWARE("radeon/new_mullins_me.bin");
+MODULE_FIRMWARE("radeon/new_mullins_ce.bin");
+MODULE_FIRMWARE("radeon/new_mullins_rlc.bin");
+MODULE_FIRMWARE("radeon/new_mullins_mec.bin");
 
 static const struct amdgpu_gds_reg_offset amdgpu_gds_reg_offset[] =
 {
@@ -916,19 +916,19 @@
 
 	switch (adev->asic_type) {
 	case CHIP_BONAIRE:
-		chip_name = "bonaire";
+		chip_name = "new_bonaire";
 		break;
 	case CHIP_HAWAII:
-		chip_name = "hawaii";
+		chip_name = "new_hawaii";
 		break;
 	case CHIP_KAVERI:
-		chip_name = "kaveri";
+		chip_name = "new_kaveri";
 		break;
 	case CHIP_KABINI:
-		chip_name = "kabini";
+		chip_name = "new_kabini";
 		break;
 	case CHIP_MULLINS:
-		chip_name = "mullins";
+		chip_name = "new_mullins";
 		break;
 	default: BUG();
 	}
Index: dist/drm/amd/amdgpu/amdgpu_gmc_v7_0.c
===================================================================
RCS file: /cvsroot/src/sys/external/bsd/drm2/dist/drm/amd/amdgpu/amdgpu_gmc_v7_0.c,v
retrieving revision 1.1
diff -u -r1.1 amdgpu_gmc_v7_0.c
--- dist/drm/amd/amdgpu/amdgpu_gmc_v7_0.c	27 Aug 2018 14:10:14 -0000	1.1
+++ dist/drm/amd/amdgpu/amdgpu_gmc_v7_0.c	3 Sep 2019 16:34:18 -0000
@@ -47,8 +47,8 @@
 static void gmc_v7_0_set_gart_funcs(struct amdgpu_device *adev);
 static void gmc_v7_0_set_irq_funcs(struct amdgpu_device *adev);
 
-MODULE_FIRMWARE("radeon/bonaire_mc.bin");
-MODULE_FIRMWARE("radeon/hawaii_mc.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_mc.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_mc.bin");
 MODULE_FIRMWARE("amdgpu/topaz_mc.bin");
 
 static const u32 golden_settings_iceland_a11[] =
Index: dist/drm/amd/amdgpu/amdgpu_uvd.c
===================================================================
RCS file: /cvsroot/src/sys/external/bsd/drm2/dist/drm/amd/amdgpu/amdgpu_uvd.c,v
retrieving revision 1.4
diff -u -r1.4 amdgpu_uvd.c
--- dist/drm/amd/amdgpu/amdgpu_uvd.c	1 Jan 2019 08:07:47 -0000	1.4
+++ dist/drm/amd/amdgpu/amdgpu_uvd.c	3 Sep 2019 16:34:20 -0000
@@ -50,11 +50,11 @@
 
 /* Firmware Names */
 #ifdef CONFIG_DRM_AMDGPU_CIK
-#define FIRMWARE_BONAIRE	"radeon/bonaire_uvd.bin"
-#define FIRMWARE_KABINI 	"radeon/kabini_uvd.bin"
-#define FIRMWARE_KAVERI 	"radeon/kaveri_uvd.bin"
-#define FIRMWARE_HAWAII 	"radeon/hawaii_uvd.bin"
-#define FIRMWARE_MULLINS	"radeon/mullins_uvd.bin"
+#define FIRMWARE_BONAIRE	"radeon/new_bonaire_uvd.bin"
+#define FIRMWARE_KABINI 	"radeon/new_kabini_uvd.bin"
+#define FIRMWARE_KAVERI 	"radeon/new_kaveri_uvd.bin"
+#define FIRMWARE_HAWAII 	"radeon/new_hawaii_uvd.bin"
+#define FIRMWARE_MULLINS	"radeon/new_mullins_uvd.bin"
 #endif
 #define FIRMWARE_TONGA		"amdgpu/tonga_uvd.bin"
 #define FIRMWARE_CARRIZO	"amdgpu/carrizo_uvd.bin"
Index: dist/drm/radeon/radeon_cik.c
===================================================================
RCS file: /cvsroot/src/sys/external/bsd/drm2/dist/drm/radeon/radeon_cik.c,v
retrieving revision 1.1
diff -u -r1.1 radeon_cik.c
--- dist/drm/radeon/radeon_cik.c	27 Aug 2018 14:38:20 -0000	1.1
+++ dist/drm/radeon/radeon_cik.c	3 Sep 2019 16:34:35 -0000
@@ -50,14 +50,14 @@
 MODULE_FIRMWARE("radeon/BONAIRE_sdma.bin");
 MODULE_FIRMWARE("radeon/BONAIRE_smc.bin");
 
-MODULE_FIRMWARE("radeon/bonaire_pfp.bin");
-MODULE_FIRMWARE("radeon/bonaire_me.bin");
-MODULE_FIRMWARE("radeon/bonaire_ce.bin");
-MODULE_FIRMWARE("radeon/bonaire_mec.bin");
-MODULE_FIRMWARE("radeon/bonaire_mc.bin");
-MODULE_FIRMWARE("radeon/bonaire_rlc.bin");
-MODULE_FIRMWARE("radeon/bonaire_sdma.bin");
-MODULE_FIRMWARE("radeon/bonaire_smc.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_pfp.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_me.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_ce.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_mec.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_mc.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_rlc.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_sdma.bin");
+MODULE_FIRMWARE("radeon/new_bonaire_smc.bin");
 
 MODULE_FIRMWARE("radeon/HAWAII_pfp.bin");
 MODULE_FIRMWARE("radeon/HAWAII_me.bin");
@@ -69,14 +69,14 @@
 MODULE_FIRMWARE("radeon/HAWAII_sdma.bin");
 MODULE_FIRMWARE("radeon/HAWAII_smc.bin");
 
-MODULE_FIRMWARE("radeon/hawaii_pfp.bin");
-MODULE_FIRMWARE("radeon/hawaii_me.bin");
-MODULE_FIRMWARE("radeon/hawaii_ce.bin");
-MODULE_FIRMWARE("radeon/hawaii_mec.bin");
-MODULE_FIRMWARE("radeon/hawaii_mc.bin");
-MODULE_FIRMWARE("radeon/hawaii_rlc.bin");
-MODULE_FIRMWARE("radeon/hawaii_sdma.bin");
-MODULE_FIRMWARE("radeon/hawaii_smc.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_pfp.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_me.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_ce.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_mec.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_mc.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_rlc.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_sdma.bin");
+MODULE_FIRMWARE("radeon/new_hawaii_smc.bin");
 
 MODULE_FIRMWARE("radeon/KAVERI_pfp.bin");
 MODULE_FIRMWARE("radeon/KAVERI_me.bin");
@@ -85,13 +85,13 @@
 MODULE_FIRMWARE("radeon/KAVERI_rlc.bin");
 MODULE_FIRMWARE("radeon/KAVERI_sdma.bin");
 
-MODULE_FIRMWARE("radeon/kaveri_pfp.bin");
-MODULE_FIRMWARE("radeon/kaveri_me.bin");
-MODULE_FIRMWARE("radeon/kaveri_ce.bin");
-MODULE_FIRMWARE("radeon/kaveri_mec.bin");
-MODULE_FIRMWARE("radeon/kaveri_mec2.bin");
-MODULE_FIRMWARE("radeon/kaveri_rlc.bin");
-MODULE_FIRMWARE("radeon/kaveri_sdma.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_pfp.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_me.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_ce.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_mec.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_mec2.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_rlc.bin");
+MODULE_FIRMWARE("radeon/new_kaveri_sdma.bin");
 
 MODULE_FIRMWARE("radeon/KABINI_pfp.bin");
 MODULE_FIRMWARE("radeon/KABINI_me.bin");
@@ -100,12 +100,12 @@
 MODULE_FIRMWARE("radeon/KABINI_rlc.bin");
 MODULE_FIRMWARE("radeon/KABINI_sdma.bin");
 
-MODULE_FIRMWARE("radeon/kabini_pfp.bin");
-MODULE_FIRMWARE("radeon/kabini_me.bin");
-MODULE_FIRMWARE("radeon/kabini_ce.bin");
-MODULE_FIRMWARE("radeon/kabini_mec.bin");
-MODULE_FIRMWARE("radeon/kabini_rlc.bin");
-MODULE_FIRMWARE("radeon/kabini_sdma.bin");
+MODULE_FIRMWARE("radeon/new_kabini_pfp.bin");
+MODULE_FIRMWARE("radeon/new_kabini_me.bin");
+MODULE_FIRMWARE("radeon/new_kabini_ce.bin");
+MODULE_FIRMWARE("radeon/new_kabini_mec.bin");
+MODULE_FIRMWARE("radeon/new_kabini_rlc.bin");
+MODULE_FIRMWARE("radeon/new_kabini_sdma.bin");
 
 MODULE_FIRMWARE("radeon/MULLINS_pfp.bin");
 MODULE_FIRMWARE("radeon/MULLINS_me.bin");
@@ -114,12 +114,12 @@
 MODULE_FIRMWARE("radeon/MULLINS_rlc.bin");
 MODULE_FIRMWARE("radeon/MULLINS_sdma.bin");
 
-MODULE_FIRMWARE("radeon/mullins_pfp.bin");
-MODULE_FIRMWARE("radeon/mullins_me.bin");
-MODULE_FIRMWARE("radeon/mullins_ce.bin");
-MODULE_FIRMWARE("radeon/mullins_mec.bin");
-MODULE_FIRMWARE("radeon/mullins_rlc.bin");
-MODULE_FIRMWARE("radeon/mullins_sdma.bin");
+MODULE_FIRMWARE("radeon/new_mullins_pfp.bin");
+MODULE_FIRMWARE("radeon/new_mullins_me.bin");
+MODULE_FIRMWARE("radeon/new_mullins_ce.bin");
+MODULE_FIRMWARE("radeon/new_mullins_mec.bin");
+MODULE_FIRMWARE("radeon/new_mullins_rlc.bin");
+MODULE_FIRMWARE("radeon/new_mullins_sdma.bin");
 
 extern int r600_ih_ring_alloc(struct radeon_device *rdev);
 extern void r600_ih_ring_fini(struct radeon_device *rdev);
@@ -2011,7 +2011,7 @@
 	switch (rdev->family) {
 	case CHIP_BONAIRE:
 		chip_name = "BONAIRE";
-		new_chip_name = "bonaire";
+		new_chip_name = "new_bonaire";
 		pfp_req_size = CIK_PFP_UCODE_SIZE * 4;
 		me_req_size = CIK_ME_UCODE_SIZE * 4;
 		ce_req_size = CIK_CE_UCODE_SIZE * 4;
@@ -2029,7 +2029,7 @@
 		break;
 	case CHIP_HAWAII:
 		chip_name = "HAWAII";
-		new_chip_name = "hawaii";
+		new_chip_name = "new_hawaii";
 		pfp_req_size = CIK_PFP_UCODE_SIZE * 4;
 		me_req_size = CIK_ME_UCODE_SIZE * 4;
 		ce_req_size = CIK_CE_UCODE_SIZE * 4;
@@ -2047,7 +2047,7 @@
 		break;
 	case CHIP_KAVERI:
 		chip_name = "KAVERI";
-		new_chip_name = "kaveri";
+		new_chip_name = "new_kaveri";
 		pfp_req_size = CIK_PFP_UCODE_SIZE * 4;
 		me_req_size = CIK_ME_UCODE_SIZE * 4;
 		ce_req_size = CIK_CE_UCODE_SIZE * 4;
@@ -2058,7 +2058,7 @@
 		break;
 	case CHIP_KABINI:
 		chip_name = "KABINI";
-		new_chip_name = "kabini";
+		new_chip_name = "new_kabini";
 		pfp_req_size = CIK_PFP_UCODE_SIZE * 4;
 		me_req_size = CIK_ME_UCODE_SIZE * 4;
 		ce_req_size = CIK_CE_UCODE_SIZE * 4;
@@ -2069,7 +2069,7 @@
 		break;
 	case CHIP_MULLINS:
 		chip_name = "MULLINS";
-		new_chip_name = "mullins";
+		new_chip_name = "new_mullins";
 		pfp_req_size = CIK_PFP_UCODE_SIZE * 4;
 		me_req_size = CIK_ME_UCODE_SIZE * 4;
 		ce_req_size = CIK_CE_UCODE_SIZE * 4;
Index: dist/drm/radeon/radeon_si.c
===================================================================
RCS file: /cvsroot/src/sys/external/bsd/drm2/dist/drm/radeon/radeon_si.c,v
retrieving revision 1.1
diff -u -r1.1 radeon_si.c
--- dist/drm/radeon/radeon_si.c	27 Aug 2018 14:38:20 -0000	1.1
+++ dist/drm/radeon/radeon_si.c	3 Sep 2019 16:34:44 -0000
@@ -49,12 +49,12 @@
 MODULE_FIRMWARE("radeon/TAHITI_rlc.bin");
 MODULE_FIRMWARE("radeon/TAHITI_smc.bin");
 
-MODULE_FIRMWARE("radeon/tahiti_pfp.bin");
-MODULE_FIRMWARE("radeon/tahiti_me.bin");
-MODULE_FIRMWARE("radeon/tahiti_ce.bin");
-MODULE_FIRMWARE("radeon/tahiti_mc.bin");
-MODULE_FIRMWARE("radeon/tahiti_rlc.bin");
-MODULE_FIRMWARE("radeon/tahiti_smc.bin");
+MODULE_FIRMWARE("radeon/new_tahiti_pfp.bin");
+MODULE_FIRMWARE("radeon/new_tahiti_me.bin");
+MODULE_FIRMWARE("radeon/new_tahiti_ce.bin");
+MODULE_FIRMWARE("radeon/new_tahiti_mc.bin");
+MODULE_FIRMWARE("radeon/new_tahiti_rlc.bin");
+MODULE_FIRMWARE("radeon/new_tahiti_smc.bin");
 
 MODULE_FIRMWARE("radeon/PITCAIRN_pfp.bin");
 MODULE_FIRMWARE("radeon/PITCAIRN_me.bin");
@@ -64,12 +64,12 @@
 MODULE_FIRMWARE("radeon/PITCAIRN_rlc.bin");
 MODULE_FIRMWARE("radeon/PITCAIRN_smc.bin");
 
-MODULE_FIRMWARE("radeon/pitcairn_pfp.bin");
-MODULE_FIRMWARE("radeon/pitcairn_me.bin");
-MODULE_FIRMWARE("radeon/pitcairn_ce.bin");
-MODULE_FIRMWARE("radeon/pitcairn_mc.bin");
-MODULE_FIRMWARE("radeon/pitcairn_rlc.bin");
-MODULE_FIRMWARE("radeon/pitcairn_smc.bin");
+MODULE_FIRMWARE("radeon/new_pitcairn_pfp.bin");
+MODULE_FIRMWARE("radeon/new_pitcairn_me.bin");
+MODULE_FIRMWARE("radeon/new_pitcairn_ce.bin");
+MODULE_FIRMWARE("radeon/new_pitcairn_mc.bin");
+MODULE_FIRMWARE("radeon/new_pitcairn_rlc.bin");
+MODULE_FIRMWARE("radeon/new_pitcairn_smc.bin");
 
 MODULE_FIRMWARE("radeon/VERDE_pfp.bin");
 MODULE_FIRMWARE("radeon/VERDE_me.bin");
@@ -79,12 +79,12 @@
 MODULE_FIRMWARE("radeon/VERDE_rlc.bin");
 MODULE_FIRMWARE("radeon/VERDE_smc.bin");
 
-MODULE_FIRMWARE("radeon/verde_pfp.bin");
-MODULE_FIRMWARE("radeon/verde_me.bin");
-MODULE_FIRMWARE("radeon/verde_ce.bin");
-MODULE_FIRMWARE("radeon/verde_mc.bin");
-MODULE_FIRMWARE("radeon/verde_rlc.bin");
-MODULE_FIRMWARE("radeon/verde_smc.bin");
+MODULE_FIRMWARE("radeon/new_verde_pfp.bin");
+MODULE_FIRMWARE("radeon/new_verde_me.bin");
+MODULE_FIRMWARE("radeon/new_verde_ce.bin");
+MODULE_FIRMWARE("radeon/new_verde_mc.bin");
+MODULE_FIRMWARE("radeon/new_verde_rlc.bin");
+MODULE_FIRMWARE("radeon/new_verde_smc.bin");
 
 MODULE_FIRMWARE("radeon/OLAND_pfp.bin");
 MODULE_FIRMWARE("radeon/OLAND_me.bin");
@@ -94,12 +94,12 @@
 MODULE_FIRMWARE("radeon/OLAND_rlc.bin");
 MODULE_FIRMWARE("radeon/OLAND_smc.bin");
 
-MODULE_FIRMWARE("radeon/oland_pfp.bin");
-MODULE_FIRMWARE("radeon/oland_me.bin");
-MODULE_FIRMWARE("radeon/oland_ce.bin");
-MODULE_FIRMWARE("radeon/oland_mc.bin");
-MODULE_FIRMWARE("radeon/oland_rlc.bin");
-MODULE_FIRMWARE("radeon/oland_smc.bin");
+MODULE_FIRMWARE("radeon/new_oland_pfp.bin");
+MODULE_FIRMWARE("radeon/new_oland_me.bin");
+MODULE_FIRMWARE("radeon/new_oland_ce.bin");
+MODULE_FIRMWARE("radeon/new_oland_mc.bin");
+MODULE_FIRMWARE("radeon/new_oland_rlc.bin");
+MODULE_FIRMWARE("radeon/new_oland_smc.bin");
 
 MODULE_FIRMWARE("radeon/HAINAN_pfp.bin");
 MODULE_FIRMWARE("radeon/HAINAN_me.bin");
@@ -109,12 +109,12 @@
 MODULE_FIRMWARE("radeon/HAINAN_rlc.bin");
 MODULE_FIRMWARE("radeon/HAINAN_smc.bin");
 
-MODULE_FIRMWARE("radeon/hainan_pfp.bin");
-MODULE_FIRMWARE("radeon/hainan_me.bin");
-MODULE_FIRMWARE("radeon/hainan_ce.bin");
-MODULE_FIRMWARE("radeon/hainan_mc.bin");
-MODULE_FIRMWARE("radeon/hainan_rlc.bin");
-MODULE_FIRMWARE("radeon/hainan_smc.bin");
+MODULE_FIRMWARE("radeon/new_hainan_pfp.bin");
+MODULE_FIRMWARE("radeon/new_hainan_me.bin");
+MODULE_FIRMWARE("radeon/new_hainan_ce.bin");
+MODULE_FIRMWARE("radeon/new_hainan_mc.bin");
+MODULE_FIRMWARE("radeon/new_hainan_rlc.bin");
+MODULE_FIRMWARE("radeon/new_hainan_smc.bin");
 
 static u32 si_get_cu_active_bitmap(struct radeon_device *rdev, u32 se, u32 sh);
 static void si_pcie_gen3_enable(struct radeon_device *rdev);
@@ -1664,7 +1664,7 @@
 	switch (rdev->family) {
 	case CHIP_TAHITI:
 		chip_name = "TAHITI";
-		new_chip_name = "tahiti";
+		new_chip_name = "new_tahiti";
 		pfp_req_size = SI_PFP_UCODE_SIZE * 4;
 		me_req_size = SI_PM4_UCODE_SIZE * 4;
 		ce_req_size = SI_CE_UCODE_SIZE * 4;
@@ -1679,7 +1679,7 @@
 		break;
 	case CHIP_PITCAIRN:
 		chip_name = "PITCAIRN";
-		new_chip_name = "pitcairn";
+		new_chip_name = "new_pitcairn";
 		pfp_req_size = SI_PFP_UCODE_SIZE * 4;
 		me_req_size = SI_PM4_UCODE_SIZE * 4;
 		ce_req_size = SI_CE_UCODE_SIZE * 4;
@@ -1694,7 +1694,7 @@
 		break;
 	case CHIP_VERDE:
 		chip_name = "VERDE";
-		new_chip_name = "verde";
+		new_chip_name = "new_verde";
 		pfp_req_size = SI_PFP_UCODE_SIZE * 4;
 		me_req_size = SI_PM4_UCODE_SIZE * 4;
 		ce_req_size = SI_CE_UCODE_SIZE * 4;
@@ -1709,7 +1709,7 @@
 		break;
 	case CHIP_OLAND:
 		chip_name = "OLAND";
-		new_chip_name = "oland";
+		new_chip_name = "new_oland";
 		pfp_req_size = SI_PFP_UCODE_SIZE * 4;
 		me_req_size = SI_PM4_UCODE_SIZE * 4;
 		ce_req_size = SI_CE_UCODE_SIZE * 4;
@@ -1723,7 +1723,7 @@
 		break;
 	case CHIP_HAINAN:
 		chip_name = "HAINAN";
-		new_chip_name = "hainan";
+		new_chip_name = "new_hainan";
 		pfp_req_size = SI_PFP_UCODE_SIZE * 4;
 		me_req_size = SI_PM4_UCODE_SIZE * 4;
 		ce_req_size = SI_CE_UCODE_SIZE * 4;